﻿function sLog(msg) {
	document.getElementById("content").innerHTML = msg + "<BR>\r\n" + document.getElementById("content").innerHTML;
}

var incrementalRollId = 0;

com.bouncyrock.talespire.extra = {

	sendSimpleDiceResult: async function (rolls, gmOnly, quiet) {
		incrementalRollId++;
		var roll = {};
		roll.rollId = (50000000000 + incrementalRollId) + "";
		roll.clientId = (await TS.clients.whoAmI()).id;
		roll.resultsGroups = [];
		for (var i = 0; i < rolls.length; i++) {
			// sLog("Adding Group "+rolls[i].name);
			var dice = rolls[i].roll.substring(rolls[i].roll.toUpperCase().indexOf("D") + 1);
			var mod = 0;
			var op = "+";
			if (dice.indexOf("+") > -1) { mod = dice.substring(dice.indexOf("+") + 1); dice = dice.substring(0, dice.indexOf("+")); }
			if (dice.indexOf("-") > -1) { mod = dice.substring(dice.indexOf("-") + 1); op = "-"; dice = dice.substring(0, dice.indexOf("-")); }
			roll.resultsGroups.push
				(
					{
						"name": rolls[i].name,
						"result":
						{
							"operator": op,
							"operands":
								[
									{ "kind": "d" + dice, "results": rolls[i].results },
									{ "value": parseInt(mod) }
								]
						}
					}
				);
		};
		roll.gmOnly = gmOnly;
		roll.quiet = quiet;
		return await TS.dice.sendDiceResult(roll.resultsGroups, roll.rollId).catch((e) => { sLog(e); });
	},

	getSimpleDiceResult: function (roll) {
		var simple = [];
		for (var i = 0; i < roll.resultsGroups.length; i++) {
			// sLog("Adding Group " + roll.resultsGroups[i].name);
			var entry = {};
			entry.name = roll.resultsGroups[i].name;
			entry.formula = roll.resultsGroups[i].result.operator;
			entry.formula = roll.resultsGroups[i].result.operands[0].kind + entry.formula + (roll.resultsGroups[i].result.operands[1].value | 0);
			entry.formula = roll.resultsGroups[i].result.operands[0].results.length + entry.formula;
			entry.results = roll.resultsGroups[i].result.operands[0].results;
			simple.push(entry);
		};
		return simple;
	},

	sendPluginMessage: function (key, value) {
		TS.players.whoAmI().then((player) => { TS.chat.send("PLUGIN:SEND:" + key + ":" + value, player.id); });
	},

	setPluginState: function (source, key, value, legacy) {
		TS.players.whoAmI().then((player) => { TS.chat.send("PLUGIN:SET:" + source + ":" + key + ":" + value + ":" + legacy, player.id); });
	},

	clearPluginState: function (source, key, legacy) {
		TS.players.whoAmI().then((player) => { TS.chat.send("PLUGIN:CLEAR:" + source + ":" + key + ":" + legacy, player.id); });
	}
}
